<?php

/*
* This class implement all admin features
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
class Admin extends User
{
	var $userSettings = array();
	var $groupSettings = array();
	
	function Admin($username, $password)
	{
		$this->User($username, $password);

		if($this->isvalid)
		{
			$this->refill_userSettings();
			$this->refill_groupSettings();
		}
	}

	function refill_userSettings()
	{
		$this->userSettings = array();
		$result = $_SESSION['db']->query("SELECT * FROM user_settings");

		while($row = $_SESSION['db']->fetch_array($result))
		{
			$name = $row['user'];
			$this->userSettings[$name]['password'] = $row['password'];
			$this->userSettings[$name]['lang'] = $row['lang'];
			$this->userSettings[$name]['theme'] = $row['theme'];
			$this->userSettings[$name]['incoming'] = $row['incoming'];
			$this->userSettings[$name]['page_refresh'] = $row['page_refresh'];
			$this->userSettings[$name]['max_download_nr'] = $row['max_download_nr'];
			$this->userSettings[$name]['max_download_vol'] = $row['max_download_vol'];
			$this->userSettings[$name]['max_name_len'] = $row['max_name_len'];
			$this->userSettings[$name]['titlebar'] = explode(":",$row['titlebar']);
			$tmp = explode(":",$row['groups']);
			for ($j = 0; $j < count($tmp); $j += 2)
			{
				$group = $tmp[$j];
				$rights = $tmp[$j + 1];
				$this->userSettings[$name]['groups'][$group] = $rights;
			}
		}
	}
	
	function refill_groupSettings() { //use $this->userSettings to fill $this->groupSettings
		$this->groupSettings = array();
		$result = $_SESSION['db']->query("SELECT * FROM group_settings");

		while($row = $_SESSION['db']->fetch_array($result)) {	
			$groupName = $row['groups'];
			$this->groupSettings[$groupName]['incoming'] = $row['incoming'];
			$this->groupSettings[$groupName]['max_download_nr'] = $row['max_download_nr'];
			$this->groupSettings[$groupName]['max_download_vol'] = $row['max_download_vol'];
		}
		
		foreach(array_keys($this->userSettings) as $user) {
			foreach($this->userSettings[$user]['groups'] as $group => $rights) {
				if($user != $group) { // filter out the rights for the user himself, this no a real group 
					$this->groupSettings[$group]['members'][$user]=$rights;
				}
			}
		}
	}
	
	function allow_show_Download($nr) {
		return TRUE;
	}
	
	function allow_add_Downloads_by_right($user) {
		return TRUE;
	}
	
	function allow_cancel_Downloads($user) {
		return TRUE;
	}	
	
	function allow_pause_Download($nr) {
		return TRUE;
	}
	
	function allow_resume_Download($nr) {
		return TRUE;
	}
	
	function allow_prio_Download($nr) {
		return TRUE;
	}
	
	function generalValidation($name, $newSettings, $test) {
		
		if((strlen($name) <= 1) or (strlen($name) > 16)) {
			$_SESSION['message'] .= sprintf(_("The %s option must be between %s and %s characters long!"), _("Name"), "2", "16")."<br />\n";
			return FALSE;
		}
		
		if(strpos(':', $name) != NULL) {
			$_SESSION['message'] .= sprintf(_("The %s option contains the illegal char \"%s\"!"), _("Name"), ":")."<br />\n";
			return FALSE;
		}
		
		if(isset($newSettings['incoming'])) {
			if(strlen($newSettings['incoming']) > 64) {
				$_SESSION['message'] .= sprintf(_("Directory path is more than %s chars long!"),"64")."<br />\n";
				unset($newSettings['incoming']);
			}
			
			if($dir = getrelpath($newSettings['incoming'])) {
					$newSettings['incoming'] = $dir;
			} else {
				$_SESSION['message'] .= sprintf(_("%s \"%s\" does not exist!"),_("Directory"), $newSettings['incoming'])."<br />\n";
				unset($newSettings['incoming']);
			}
		}
		
		if(isset($newSettings['max_download_nr'])) {
			if(!is_numeric($newSettings['max_download_nr']) OR ((int)$newSettings['max_download_nr'] < 0) OR ((int)$newSettings['max_download_nr'] > 9999)) {
				$_SESSION['message'] .= sprintf(_("%s must be a number between \"%s\" and \"%s\"!"), _("Max. Download No."), "0", "9999")."<br />\n";
				unset($newSettings['max_download_nr']);
			}
		}
		if(isset($newSettings['max_download_vol'])) {
			if(!is_numeric($newSettings['max_download_vol']) OR ((int)$newSettings['max_download_vol'] < 0) OR ((int)$newSettings['max_download_vol'] > 99999999)) {
				$_SESSION['message'] .= sprintf(_("%s must be a number between \"%s\" and \"%s\"!"), _("Max. Download Volume"), "0", "99999999")."<br />\n";
				unset($newSettings['max_download_vol']);
			}
		}
		
		if($test == "group") { return $newSettings; }
		
		if(isset($newSettings['lang'])) {
			if(!is_file($_SESSION['core']->subDirs['lang_dir'].$newSettings['lang']."/LC_MESSAGES/messages.mo")) {
				$_SESSION['message'] .= sprintf(_("The %s variable is invalid!"),_("Language"))."<br \>".sprintf(_("No \"%s\" found!"), $_SESSION['core']->subDirs['lang_dir'].$newSettings['lang']."/LC_MESSAGES/messages.mo")."<br />\n";
				unset($newSettings['lang']);
			}
		}
		
		if(isset($newSettings['theme'])) {
			if(!is_file($_SESSION['core']->subDirs['theme_dir'].$newSettings['theme']."/template.php")) {
				$_SESSION['message'] .= sprintf(_("The %s variable is invalid!"),_("Theme"))."<br \>".sprintf(_("No \"%s\" found!"), $_SESSION['core']->subDirs['theme_dir'].$newSettings['theme']."/template.php")."<br />\n";
				unset($newSettings['theme']);
			}
		}
		
		if(isset($newSettings['page_refresh'])) {
			if(!is_numeric($newSettings['page_refresh']) OR ((int)$newSettings['page_refresh'] != $newSettings['page_refresh']) OR ((int)$newSettings['page_refresh'] < -1) OR ((int)$newSettings['page_refresh'] > 9999)) {
				$_SESSION['message'] .= sprintf(_("%s must be a number between \"%s\" and \"%s\"!"), _("Page Refresh"), "-1", "9999");
				unset($newSettings['page_refresh']);
			}
		}
		if(isset($newSettings['max_name_len'])) {
			if(!is_numeric($newSettings['max_name_len']) OR ((int)$newSettings['max_name_len'] < 5) OR ((int)$newSettings['max_name_len'] > 9999)) {
				$_SESSION['message'] .= sprintf(_("%s must be a number between \"%s\" and \"%s\"!"), _("Max. Name Length"), "5", "9999")."<br />\n";
				unset($newSettings['max_name_len']);
			}
		}
		if(isset($newSettings['groups'])) {
			if(!in_array($name, explode(':', $newSettings['groups']))) {
				$_SESSION['message'] .= sprintf(_("The User \"%s\" must be member of his own Group!"), $name)."<br />\n";
				unset($newSettings['groups']);
			}
		}
		
		return $newSettings;
	}
	
	function addUser($username, $newSettings) {
	
		if(empty($username)) {
			$_SESSION['message'] .= sprintf(_("No %s specified!"), _("Name"))."<br />\n";
			return FALSE;
		}

		//general permissions
		if( in_array($username, array_keys($this->userSettings)) OR in_array($username, array_keys($this->groupSettings)) ) {
			$_SESSION['message'] .= sprintf(_("User/Group \"%s\" already exist!"), $username)."<br />\n";
			return FALSE;
		}
		
		$newSettings = $this->generalValidation($username, $newSettings, "user");
		if(count($newSettings) == 0 OR !$newSettings) { return FALSE; }
		
		//add User
		$_SESSION['db']->query("INSERT INTO user_settings (user, password, titlebar, lang, theme, incoming, max_download_nr, max_download_vol, groups, page_refresh, max_name_len) VALUES ('".
		$username."','".md5($newSettings['password'])."','".$newSettings['titlebar']."','".$newSettings['lang']."','".$newSettings['theme']."','".
		$newSettings['incoming']."','".$newSettings['max_download_nr']."','".$newSettings['max_download_vol']."','".$newSettings['groups']."','".$newSettings['page_refresh']."','".$newSettings['max_name_len']."')"  );
		
		$this->refill_userSettings();
		$this->refill_groupSettings();
		$_SESSION['message'] .= sprintf(_("Create User \"%s\"."),$username)."<br />\n";
		return TRUE;
	}
	
	//del User and his personal group //del searches is no good way
	function delUser($username)
	{
		if($username == 'admin') {//not nessesary
			$_SESSION['message'] .= sprintf(_("Removing User \"%s\" is not possible!"),"admin")."<br />\n";
			return FALSE;
		}
		
		if(!in_array($username, array_keys($this->userSettings))) {
			$_SESSION['message'] .= sprintf(_("User \"%s\" does not exist!"), $username)."<br />\n";
			return FALSE;
		}

		$_SESSION['db']->query("DELETE FROM user_settings WHERE user='".$username."'"  );
		$_SESSION['db']->query("DELETE FROM searches WHERE user='".$username."'" );
		$_SESSION['db']->query("DELETE FROM downloads WHERE owner='".$username."'" );
		
		$this->refill_downloads();
		$this->refill_userSettings();
		$this->refill_groupSettings();
		updateCommitScript();
		$_SESSION['message'] .= sprintf(_("%s \"%s\" removed."), _("User"), $username)."<br />\n";
		return TRUE;
	}
	
	function setUserSettings($username, $newSettings) {
		if(!in_array($username,array_keys($this->userSettings))) {
			$_SESSION['message'] .= sprintf(_("%s \"%s\" does not exist!"),_("User"), $username)."<br />\n";
			return FALSE;
		}

		$newSettings = $this->generalValidation($username, $newSettings, "user");
		if(count($newSettings) == 0 OR !$newSettings) { return FALSE; }
		
		//change form of titlebar
		if(isset($newSettings['titlebar'])) {
			$newSettings['titlebar'] = implode(':', $newSettings['titlebar']);
		}

		$ns = "";
		foreach($newSettings as $key => $value) {
			$ns.= $key."='".$value."', ";
		}
		$ns = substr($ns, 0, -2);
		
		$_SESSION['db']->query("UPDATE user_settings SET ".$ns." WHERE user='".$username."'");
		$this->refill_userSettings();
		$this->refill_groupSettings();
		updateCommitScript();
		$_SESSION['message'] .= sprintf(_("Settings for %s \"%s\" set."), _("User"), $username)."<br />\n";
		if($username == "admin") { $this->refill_settings(); } //does only make sense for admin but causes aha effects! ;)
		return TRUE;
	}
	
	function getAllUsers() {
		$result = $_SESSION['db']->query("SELECT user FROM user_settings");
		$users = array();
		while($temp = $_SESSION['db']->fetch_array($result))
		{
			$users[] = $temp['user'];
		}
		return $users;
	}
	
	function getAllGroups() {
		$result = $_SESSION['db']->query("SELECT groups FROM group_settings");
		$groups = array();
		while($temp = $_SESSION['db']->fetch_array($result)){
			$groups[] = $temp['groups'];
		}
		return $groups;
	}
	
	function addGroup($groupname,$newSettings) {
		if(empty($groupname)) {
			$_SESSION['message'] .= sprintf(_("No %s specified!"), _("Group"))."<br />\n";
			return FALSE;
		}
		
		if(in_array($groupname,array_keys($this->groupSettings)) OR in_array($groupname,array_keys($this->userSettings))) {
			$_SESSION['message'] .= sprintf(_("User/Group \"%s\" already exist!"), $groupname)."<br />\n";
			return FALSE;
		}
		
		$_SESSION['db']->query("INSERT INTO group_settings ( groups, incoming, max_download_nr, max_download_vol ) VALUES ( '".$groupname."', '".$newSettings['incoming']."' , '".$newSettings['max_download_nr']."' , '".$newSettings['max_download_vol']."' )" );
		$this->refill_userSettings();
		$this->refill_groupSettings();
		$_SESSION['message'] .= sprintf(_("%s \"%s\" added."), _("Group"), $groupname)."<br />\n";
		return TRUE;
	}
	
	function delGroup($groupname) {
		if(empty($groupname)){ $_SESSION['message'] .= sprintf(_("No %s selected!"),_("Group"))."<br />\n"; }
		
		//if the $groupname is the user, this should never happen
		if(in_array($groupname,array_keys($this->userSettings))) {
			$_SESSION['message'] .= sprintf(_("Group cannot deleted. Remove User \"%s\" first."), $groupname, $groupname)."<br />\n";
			return FALSE;
		}
		
		if(!in_array($groupname,$this->getAllGroups())) {
			$_SESSION['message'] .= sprintf(_("%s \"%s\" does not exist."), _("Group"), $groupname)."<br />\n";
			return FALSE;
		}
		
		//remove all members when the group has still members
		if($this->groupSettings[$groupname]['members'] != NULL) {
			$user_array = array_keys($this->groupSettings[$groupname]['members']);
			$this->delGroupMembers($groupname,$user_array);
		}
		
		//remove downloads from download list (the are not deleted, they stay ownerles)
		$_SESSION['db']->query("DELETE FROM downloads WHERE owner='".$groupname."'");
		
		//remove group entry in db table group_settings
		$_SESSION['db']->query("DELETE FROM group_settings WHERE groups='".$groupname."'");
		
		$this->refill_downloads();
		$this->refill_userSettings();
		$this->refill_groupSettings();
		updateCommitScript();
		$_SESSION['message'] .= sprintf(_("%s \"%s\" removed. Downloads may have no owner."), _("Group"), $groupname)."<br />\n";
		return TRUE;
	}
	
	// remove  users from a group //better rename to remGroupMembers
	function delGroupMembers($groupname,$user_array) {
		if($groupname == NULL){ $_SESSION['message'] .= sprintf(_("No %s selected!"), _("Group")); return FALSE; }
		if($user_array == NULL){ $_SESSION['message'] .= sprintf(_("No %s selected!"), _("User")); return FALSE; }
		
		//if the $groupname is the user, this should never happen
		if(in_array($groupname,$user_array)) {
			$_SESSION['message'] .= sprintf(_("User \"%s\" cannot be removed from Group \"%s\"."), $groupname, $groupname)."<br />\n";
			return FALSE;
		}
		
		foreach($user_array as $user) {
			$groupString = "";
			if(isset($this->userSettings[$user]['groups'][$groupname])) {
				foreach($this->userSettings[$user]['groups'] as $group => $rights) { //rebuild all group data of each user in $user_array and drop group entry of group $groupname
					if($group != $groupname){ $groupString .= $group.':'.$rights.':'; }
				}
				$groupString = substr($groupString,0,-1);
				$_SESSION['db']->query("UPDATE user_settings SET groups='".$groupString."' WHERE user='".$user."'");
				$_SESSION['message'] .= sprintf(_("%s \"%s\" removed from %s \"%s\"."), _("User"), $user, _("Group"), $groupname)."<br />\n";
			} else {
				$_SESSION['message'] .= sprintf(_("%s is no member of Group \"%s\"!"),$user,$groupname)."<br />\n";
			}
		}
		$this->refill_userSettings();
		$this->refill_groupSettings();
		updateCommitScript();
		return TRUE;
	}
	
	// add users to a group
	function addGroupMembers($groupname,$user_array) {
		$defaultRights = "31";
		if($groupname == NULL) {
			$_SESSION['message'] .= sprintf(_("No %s selected!"), _("Group"))."<br />\n";
			return FALSE;
		}
		
		if($user_array == NULL){
			$_SESSION['message'] .= sprintf(_("No %s selected!"), _("User"))."<br />\n";
			return FALSE;
		}
		
		foreach($user_array as $user) {
			$groupString = "";
			if(!isset($this->userSettings[$user]['groups'][$groupname])) { //when user is not in the group
				if(!empty($this->userSettings[$user]['groups'])) {//when user is at least in one group, prevent "::"entry
					foreach($this->userSettings[$user]['groups'] as $group => $rights) {
						$groupString .= $group.':'.$rights.':';
					}
				}
				$groupString .= $groupname.":".$defaultRights;
				$_SESSION['db']->query("UPDATE user_settings SET groups='".$groupString."' WHERE user='".$user."'");
				$_SESSION['message'] .= sprintf(_("%s \"%s\" added to %s \"%s\"."), _("User"), $user, _("Group"), $groupname)."<br />\n";
			} else {
				$_SESSION['message'] .= sprintf(_("User \"%s\" is already member of group \"%s\"!"), $user, $groupname)."<br />\n";
			}
		}
		$this->refill_userSettings();
		$this->refill_groupSettings();
		return TRUE;
	}
	
	function setGroupSettings($groupname, $newSettings)
	{
		if(!in_array($groupname, array_keys($this->groupSettings))) {
			$_SESSION['message'] .= sprintf(_("%s \"%s\" does not exist!"), _("Group"), $groupname)."<br />\n";
			return FALSE;
		}
	
		$newSettings = $this->generalValidation($groupname, $newSettings, "group");
		if(count($newSettings) == 0 OR !$newSettings) { return FALSE; }
		
		$ns = "";
		foreach($newSettings as $key => $value) {
			$ns .= $key."='".$value."', ";
		}
		$ns = substr($ns,0,-2);

		$_SESSION['db']->query("UPDATE group_settings SET ".$ns." WHERE groups='".$groupname."'");
		$this->refill_groupSettings();
		updateCommitScript(); //in case the incoming dir ist altered
		$_SESSION['message'] .= sprintf(_("Settings for %s \"%s\" set."),_("Group"),$groupname)."<br />\n";
		return TRUE;
	}
}
?>