<?php
/*
* Everything user related
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/

class User {

	var $isvalid = TRUE;
	
	var $username = NULL;
	
	var $downloads = array();
	
	var $searches = array();
	
	var $groups;
	var $titlebar;
	var $lang;
	var $theme;
	var $incoming;
	var $max_download_nr;
	var $max_download_vol;

	function User($username, $password) {
		// verify password
		
		if(!$_SESSION['core']->use_http_auth) {
			$result = $_SESSION['db']->query( "SELECT user, password FROM user_settings WHERE (password='".$password."') AND (user='".$username."')"  );
			
			if($_SESSION['db']->num_rows($result) == 0) {
				$this->isvalid = FALSE;
			}
		}

		if($this->isvalid) {
			//set username
			$this->username = $username;

			//load data
			$this->refill_settings();
			$this->refill_downloads();
			//delete old searches
			$this->search_delAll();
		}
	}

	//=========refill* section========//
	
	function refill_searches() {
		$result = $_SESSION['db']->query("SELECT searchnum FROM searches WHERE user='".$this->username."'"  );
		//get("searchnum", "searches", array("user", "sdf"))
		$ok = FALSE;
		while($tmp = $_SESSION['db']->fetch_array($result)) {
			$this->searches[] = $tmp['searchnum'];
			$ok = TRUE;
		}
		if(!$ok) {
			$this->searches = array();
		}
	}
	
	function refill_settings() {
		//$this->settings = array();
		
		//set settings
		$settings = $this->get_settings($this->username, "titlebar, lang, theme, incoming, max_download_nr, groups, page_refresh, max_download_vol, max_name_len");
		
		foreach($settings as $key => $value) {
			$this->{$key} = $value;
		}
		
		//format titlebar to array
		$this->titlebar = explode(":", $this->titlebar);
		
		//format group distinction with group rights
		$groups = explode(":", $this->groups);
		$temp = array();
		for($i = 0; $i < count($groups); $i += 2)
		{
			$temp[$groups[$i]] = $groups[$i + 1];
		}
		$this->groups = $temp;
		//every user is in his own group with all rights (add, cancel, pause, resume), see is default when user is groupmember
	}

	function refill_downloads() {
		$this->downloads = array();
		
		$query = '';
		foreach($this->groups as $group => $right) { //$this->groups cannot be empty because every user must be in his own group
			$query.= " owner='".$group."' OR";
		}
		$query = substr($query,0,-2);
		
		if($this->username == 'admin'){ $query = " owner LIKE '%'"; } //admin see all files
		
		$result = $_SESSION['db']->query("SELECT owner, nr FROM downloads WHERE ".$query);
		
		$ok = FALSE;
		while($tmp = $_SESSION['db']->fetch_array($result)) {
			$this->downloads[$tmp['nr']][] = $tmp['owner']; //nr => array(owner1, owner2 ...)
			$ok = TRUE;
		}
		
		if(!$ok) {
			$this->downloads = array();
		}
	}

	function remove_finished() {

		$client_nrs = $_SESSION['interface']->get_all_nrs();
		
		$db_nrs = array_keys($this->downloads);

		foreach($db_nrs as $nr) {
			if(!in_array($nr, $client_nrs)) {;
				$_SESSION['db']->query("DELETE FROM downloads WHERE nr='".$nr."'");
			}
		}
	}

/*
* verify_db() resets all download No. by hash and delete non existing entries
* The verification process can take a while, depend on the number of downloads
*
*/
	function verify_db($all = FALSE) {
		if(!$_SESSION['interface']->alive()) { return; }
		
		echo _("Please Wait. Validating Download Database.")."<br>\n";
		flush();
		
		$_SESSION['db']->query("DELETE FROM downloads WHERE nr='' OR hash=''");
		
		//get list of own hashes from database
		$query = '';
		if($all) {
			$query = " owner LIKE '%'";
		} else {
			foreach($this->groups as $group => $right) {
				$query.= " owner='".$group."' OR";
			}
			$query = substr($query, 0, -2);
		}
		
		$result = $_SESSION['db']->query("SELECT hash FROM downloads WHERE ".$query);
		
		$hashes = array();
		while($tmp = $_SESSION['db']->fetch_array($result)) {
			$hashes[] = $tmp['hash'];
		}
		if(empty($hashes)) { return; }
		
		$_SESSION['interface']->cache_reset(); //needed to get fresh values
		$hashes_nrs = $_SESSION['interface']->get_nr($hashes);
	
		/*
		foreach($hashes as $hash) {
			if(!array_key_exists($hash, $hashes_nrs)) {
				//echo "DELETE FROM downloads WHERE hash='".$hash."'<br>";
				$_SESSION['db']->query("DELETE FROM downloads WHERE hash='".$hash."'");
			} else {
				//echo "UPDATE downloads SET nr='".$hashes_nrs[$hash]."' WHERE hash='".$hash."'<br>";
				$_SESSION['db']->query("UPDATE downloads SET nr='".$hashes_nrs[$hash]."' WHERE hash='".$hash."'");
			}
		}
		*/
		
		foreach($hashes_nrs as $hash => $nr) {
			if($nr) {	// remove download by hash  from DB, because it does not exist
				//echo "UPDATE downloads SET nr='".$nr."' WHERE hash='".$hash."'"."</br>\n";
				$_SESSION['db']->query("UPDATE downloads SET nr='".$nr."' WHERE hash='".$hash."'");
			} else {
				//echo "DELETE FROM downloads WHERE hash='".$hash."'"."</br>\n";
				$_SESSION['db']->query("DELETE FROM downloads WHERE hash='".$hash."'");
			}
		}
	}

	//=========allow* section========//
	
	function allow_show_Menu($item) {
		return in_array($item, $this->titlebar);
	}
	
	function allow_show_Search($searchnum) {
		if (in_array($searchnum, $this->searches)) {
			return TRUE;
		} else {
			return FALSE;	
		}
	}

	function allow_show_Download($nr) {
		return array_key_exists($nr,$this->downloads);
	}

	function allow_add_Downloads($count, $size, $toUser) {
	
		if(!$this->allow_add_Downloads_by_right($toUser)) {
			$_SESSION['message'] .= _("Cannot download!")." ".sprintf(_("No permission to add downloads to User/Group \"%s\"!"), $toUser).BN;
			return FALSE;
		} elseif(!$this->allow_add_Downloads_by_count($count,$toUser)) {
			$_SESSION['message'] .= _("Cannot download!")." ".sprintf(_("Maximum download %s for User/Group \"%s\" reached!"), _("Count"), $toUser).BN;
			return FALSE;
		} elseif(!$this->allow_add_Downloads_by_size($size, $toUser)) {
			$_SESSION['message'] .= _("Cannot download!")." ".sprintf(_("Maximum download %s for User/Group \"%s\" reached!"), _("Volume"), $toUser).BN;
			return FALSE;
		}
		return TRUE;
	}
	
	
	function allow_add_Downloads_by_right($user) {
		$rights = $this->groups[$user];
		return ($rights%2 >= 1);
	}
	
	function allow_cancel_Downloads($user) {	
		$rights = $this->groups[$user];
		return ($rights%4 >= 2);
	}	
	
	function allow_pause_Download($nr) {
		return $this->allow_resume_Download($nr);
	}
	
	function allow_resume_Download($nr) {	
		$groups = $this->get_Owner($nr);
		foreach($groups as $group) {
			$rights = $this->groups[$group];
			if($rights%8 < 4){ return FALSE; } //when one (or more ) of the owners don't allow it, default is allow
		}
		return TRUE;
	}
	
	function allow_prio_Download($nr) {	
		$groups = $this->get_Owner($nr);
		foreach($groups as $group) {
			$rights = $this->groups[$group];
			if($rights%16 < 8){ return FALSE; } //when one (or more ) of the owners don't allow it, default is allow
		}
		return TRUE;
	}

	function allow_rename_Download($nr) {
		$groups = $this->get_Owner($nr);
		foreach($groups as $group) {
			$rights = $this->groups[$group];
			if($rights%32 < 16){ return FALSE; } //when one (or more ) of the owners don't allow it, default is allow
		}
		return TRUE;
	}
	
	function allow_add_Downloads_by_count($add_downloads, $toUser) {
		if(empty($toUser)) { return FALSE; }
	
		$result1 = $_SESSION['db']->query("SELECT nr FROM downloads WHERE owner='".$toUser."'");
		$current_downloads = $_SESSION['db']->num_rows($result1);

		$result2 = $this->get_settings($toUser, "max_download_nr");
		if($current_downloads + (int)$add_downloads <= $result2['max_download_nr']) {
			return TRUE;
		}
		return FALSE;
	}
	
	function allow_add_Downloads_by_size($add_size, $toUser) {
		if(empty($toUser)) { return FALSE; }
		$current_size = 0;

		$result1 = $_SESSION['db']->query("SELECT nr FROM downloads WHERE owner='".$toUser."'");
		
		while($line_array = $_SESSION['db']->fetch_array($result1)) {
			$current_size += $_SESSION['interface']->get_size($line_array['nr']);
		}
		
		//optionally add the size of the users incoming dir
		if($_SESSION['core']->include_incoming_size) {
			$incoming = $this->get_settings($toUser, "incoming"); 
			$current_size += get_dir_size(getabspath($incoming["incoming"]), FALSE);
		}
		$result2 = $this->get_settings($toUser, "max_download_vol");
		
		if($current_size + $add_size <= ($result2['max_download_vol']*1048576)) { // max_download_vol need to be converted from MB to Bytes
			return TRUE;
		}
		return FALSE;
	}
	
	function get_settings($user_name, $vars) {
		$result = $_SESSION['db']->query("SELECT ".$vars." FROM user_settings WHERE user='".$user_name."'"  );
		
		if($_SESSION['db']->num_rows($result) == 0) {  //if no user exists it must be a group
			$result = $_SESSION['db']->query(  "SELECT ".$vars." FROM group_settings WHERE groups='".$user_name."'"  );
		}
		return $_SESSION['db']->fetch_array($result);
	}
	
	//=======*Owner===========//
	function get_Owner($nr) {
		$result = $_SESSION['db']->query(  "SELECT owner FROM downloads WHERE nr='".$nr."'"  );
		$groups = array();
		while($tmp = $_SESSION['db']->fetch_array($result)) {
			$groups[] = $tmp['owner'];
		}
		return array_intersect($groups, array_keys($this->groups));
	}
	
	function add_Owner($nrs, $toUser) {
		$hash = $_SESSION['interface']->get_hash($nrs);
		$file_name = $_SESSION['interface']->get_name($nrs);
		
		if(empty($toUser)) { echo "ERROR in add_Owner(); invalid Owner<br>\n"; return FALSE; }
		
		$nrs_alr = array();
		$nrs_add = array();
		foreach((array) $nrs as $nr) {
			if(!$this->downloaded_by_user($nr, $toUser)) {
				$_SESSION['db']->query("INSERT INTO downloads ( owner, hash, nr) VALUES ( '".$toUser."' , '".$hash[$nr]."' , '".$nr."' )" );
				$nrs_add[] = $nr;
			} else {
				$nrs_alr[] = $nr;
			}
		}
		
		if(!empty($nrs_add)) {
			$_SESSION['message'] .= sprintf(_("Added downloads to User/Group \"%s\":"), $toUser)."<br \>\n";
			$_SESSION['message'] .= getNameList($nrs_add);
		}
		
		if(!empty($nrs_alr)) {
			$_SESSION['message'] .= sprintf(_("User/Group \"%s\" is already owner of downloads:"), $toUser)."<br \>\n";
			$_SESSION['message'] .= getNameList($nrs_alr); 
		}
		
		$this->refill_downloads();
		updateCommitScript();
		return TRUE;
	}
	
	function addDownloads($nrs, $user) { //only used in ./lib/searches.php and ./lib/dlLink.php
	
		if(empty($user)) { echo "ERROR in addDownloads(); invalid User<br>\n"; return FALSE; }
		
		foreach((array) $nrs as $nr) {
			if($hash = $_SESSION['interface']->get_hash($nr)) {
				$_SESSION['db']->query(  "INSERT INTO downloads (owner, hash, nr) values ('".$user."', '".$hash."', '".$nr."' )"  );
			} else { echo 'ERROR in addDownloads(); invalid return value for NR:"'.$nr.'"'.BN; return FALSE; }
		}
		
		$this->refill_downloads();
		updateCommitScript();
		return TRUE;
	}

	function removeDownloads($nrs, $user) { //only used in ./lib/downloads.php
	
		if(empty($user)) { echo 'ERROR in removeDownloads(); invalid User'.BN; return FALSE; }
		
		foreach((array) $nrs as $nr) {
			$_SESSION['db']->query(  "DELETE FROM downloads WHERE nr='".$nr."' AND owner='".$user."'"  );
		}
		
		$this->refill_downloads();
		updateCommitScript();
		return TRUE;
	}

	
	function getOwnerString($nr) {
		if($owner_array = $this->downloads[$nr]) {
			sort($owner_array);
			return implode(" ",$owner_array);
		}
		return "-";
	}
	
	function downloaded_by_user($nr, $user_name) {
		$result = $_SESSION['db']->query(  "SELECT hash FROM downloads WHERE nr='".$nr."' AND owner='".$user_name."'"  );
		if ($_SESSION['db']->num_rows($result) > 0) {
			return TRUE;
		}
		return FALSE;
	}
	
	function downloaded_by_others($nr,$user_name) {
		$result = $_SESSION['db']->query(  "SELECT nr FROM downloads WHERE nr='".$nr."' AND owner NOT LIKE '".$user_name."'"  );
		if ($_SESSION['db']->num_rows($result) == 0) {
			return FALSE;
		}
		return TRUE;
	}
	
	function num_of_downloads($nr) {
		
		$result = $_SESSION['db']->query(  "SELECT nr FROM downloads WHERE nr='".$nr."'"  );
		return $_SESSION['db']->num_rows($result);
		
	}

	//=========serach*===========//
	
	function search_add($searchnum) {
		if(!$this->allow_show_Search($searchnum))
		{
			$_SESSION['db']->query(  "INSERT INTO searches (searchnum, user) VALUES ('".$searchnum."', '".$this->username."')"  );
			$this->searches[] = $searchnum;
		} else { return FALSE; }
	}
	
	function search_del($searchnum) {
		$_SESSION['db']->query(  "DELETE FROM searches WHERE (searchnum='".$searchnum."') AND (user='".$this->username."')"  );
		$this->refill_searches();
	}
	
	//search_delAll delete all searches of the user corresponding to the database-table
	function search_delAll() {
		$result = $_SESSION['db']->query(  "SELECT searchnum FROM searches WHERE user='".$this->username."'"  );
		
		$searchnums = array();
		while($tmp = $_SESSION['db']->fetch_array($result)) {
			$searchnums[] = $tmp['searchnum'];
		}
		
		if(count($searchnums) != 0) {
			$_SESSION['interface']->delSearches($searchnums);
			$_SESSION['db']->query(  "DELETE FROM searches WHERE user='".$this->username."'"  );
		}
	}
	//need to merge with setSettings
	function setUserPassword($user,$password) {
		
		if($user != $this->username AND !in_array($user, array_keys($this->userSettings))) { //bad style to use $this->userSettings only implicit for admin
			$_SESSION['message'] .=  sprintf(_("%s \"%s\" does not exist!"), _("User"), $user).BN;
			return FALSE;
		}
	
		if($user != $this->username AND $this->username != "admin") { //this case should never happen
			$_SESSION['message'] .= _("No Permission!")."<br \>\n";
			return FALSE;
		}
		$_SESSION['db']->query("UPDATE user_settings SET password='".md5($password)."' WHERE user='".$user."'");
		$_SESSION['message'] .= sprintf(_("Password for User \"%s\" set."), $user).BN;
		return TRUE;
	}
	//need to merge with admin function
	function setOwnSettings($newSettings) {
		//check the new settings
		if(isset($newSettings['lang'])) {
			if(!is_file($_SESSION['core']->subDirs['lang_dir'].$newSettings['lang']."/LC_MESSAGES/messages.mo")) {
				$_SESSION['message'] .= sprintf(_("The %s variable is invalid!"),_("Language"))."\n".sprintf(_("No \"%s\" found!"), $_SESSION['core']->subDirs['lang_dir'].$newSettings['lang']."/LC_MESSAGES/messages.mo").BN;
				return FALSE;
			}
		}
		
		if(isset($newSettings['theme'])) {
			if(!is_file($_SESSION['core']->subDirs['theme_dir'].$newSettings['theme']."/template.php")) {
				$_SESSION['message'] .= sprintf(_("The %s variable is invalid!"),_("Theme"))."\n".sprintf(_("No \"%s\" found!"),$_SESSION['core']->subDirs['theme_dir'].$newSettings['theme'].'/template.php').BN;
				return FALSE;
			}
		}
		
		if(isset($newSettings['page_refresh'])) {
			if(!is_numeric($newSettings['page_refresh']) OR ((int)$newSettings['page_refresh'] != $newSettings['page_refresh']) OR ((int)$newSettings['page_refresh'] < -1) OR ((int)$newSettings['page_refresh'] > 9999)) {
				$_SESSION['message'] .= sprintf(_("%s must be a number between \"%s\" and \"%s\"!"), _("Page Refresh"), "-1", "9999").BN;
				return FALSE;
			}
		}
		
		if(isset($newSettings['max_name_len'])) {
			if(!is_numeric($newSettings['max_name_len']) OR ((int)$newSettings['max_name_len'] < 5) OR ((int)$newSettings['max_name_len'] > 9999)) {
				$_SESSION['message'] .= sprintf(_("%s must be a number between \"%s\" and \"%s\"!"), _("Max. Name Length"), "5", "9999").BN;
				return FALSE;
			}
		}
		
		//change form of titlebar
		if(isset($newSettings['titlebar'])) {
			$newSettings['titlebar'] = implode(':', $newSettings['titlebar']);
		}
		
		$ns = "";
		foreach($newSettings as $key => $value) {
			$ns.= $key."='".$value."', ";
		}
		$ns = substr($ns,0,-2);

		$_SESSION['db']->query("UPDATE user_settings SET ".$ns." WHERE user='".$this->username."'");
		$this->refill_settings();
		if($this->username == "admin") { $this->refill_userSettings(); }
		$_SESSION['message'] .= sprintf(_("Settings for %s \"%s\" set."), _("User"), $this->username)."<br \>\n";
		return TRUE;
	}
	
	function getMembership() {
		$result = $_SESSION['db']->query(  "SELECT groups FROM user_settings WHERE user='".$this->username."'");
		$group_rights = array();
		$row = $_SESSION['db']->fetch_array($result);
		$tmp = explode(":", $row['groups']);
		for ($j = 0; $j < count($tmp); $j += 2 ) {
			$group = $tmp[$j];
			$rights = $tmp[$j+1];
			$group_rights[$group]=$rights;
		}
		return $group_rights;
	}
}
?>