<?php

/**
* Presents form to edit options
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
* @author   Don Seiler <don@NOSPAM.seiler.us>
*/
function opt_all()
{
	return opt(TRUE);
}

function opt($all = FALSE)
{
	$content = NULL;
	$op = ($all)?"opt_all":"opt";
	$_SESSION['headline'] = _("Client Options");
	$options = array();
	$options = $_SESSION['interface']->getOptions($all);

	// If new options were submitted, compare to old ones and set differences
	if(isset($_REQUEST["options"]) && is_array($_REQUEST["options"]))
	{
		$newOptions = array();
		foreach($_REQUEST["options"] as $key => $value)
		{
			if(trim($value) != trim($options[$key])) {
				$_SESSION['message'] .= _("Option changed") . ": $key: $options[$key] => $value<br />";
				$newOptions[$key] = trim($value);
				$options[$key] = trim($value); //update Options
			}
		}
		$_SESSION['interface']->setOptions($newOptions);

		if($_SESSION['interface']->saveOptions()) {
			$_SESSION['messsage'] .= _("Configuration files saved.").BN;
		} else {
			$_SESSION['messsage'] .= _("Could NOT save configuration files!").BN;
		}
	}

	// Sort
	$sortorder = NULL;
	if(isset($_REQUEST["SORTORDER"])) {
		$sortorder = $_REQUEST["SORTORDER"];
	}
	if ($all AND !isset($sortorder)) { $sortorder = "ASC"; }
        if(isset($sortorder)) {
		if($sortorder == "DESC") { krsort($options); } else { ksort($options); }
		reset($options);
        }
	
	$content .= '<form name="optionsform" action="index.php?CORE_OP='.$op.'" method="post">'.NL;

	$out = array();
	foreach($options as $key => $value) {

		$sub = "";
		if($value == "true") {
			$sub .= '<select name="options['.$key.']" style="width: 100%;">';
			$sub .= '<option value="false">false</option>';
			$sub .= '<option value="true" selected>true</option>';
			$sub .= '</select>';
		} elseif($value == "false") {
			$sub .= '<select name="options['.$key.']"  style="width: 100%;">';
			$sub .= '<option value="false" selected>false</option>';
			$sub .= '<option value="true">true</option>';
			$sub .= '</select>';
		
		} else {
			$sub .= '<input type="text" size="12" name="options['.$key.']" value="'.$value.'" />';
		}
		$out[$key] = $sub;
	}
	$options = array();

	$content .= '<table cellspacing="0" cellpadding="2" border="0">'.NL;

	//print header
	$content .= '<tr class="bg_dark">'.NL;
	$content .= '<th><a class="header" href="index.php?CORE_OP='.$op.'&SORTORDER=ASC">&darr;</a>'._("Key").'<a class="header" href="index.php?CORE_OP='.$op.'&SORTORDER=DESC">&uarr;</a></th>'.NL;
	$content .= '<th>'._("Value")."</th>\n";
	$content .= "</tr>\n";
	
	$c = 0;
	foreach($out as $key => $value) {
		if($c%2 == 0)	{ $content .= '<tr class="alt_list">'; }
		else 		{ $content .= '<tr class="list">'; }
		$content .= '<td>'.$key.'</td><td>'.$value.'</td>';
		$content .= "</tr>\n";
		$c++;
	}
	$content .= '</table>'.NL;
	
	$content .= BN;
	$content .= '<input type="submit" value="'._("Save Settings")."\" />\n";
	
	if(!$all) {
		$content .= "<br /><br />\n";
		$content .= '<b><a href="index.php?CORE_OP=opt_all">'._("View All Options")."</a></b>\n";
	}
	
	$content .= "</form>\n";
	return $content;
}

/*
*  opt_action save new client settings
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function opt_action() {
//Saves mldonkey options to disk
	if(isset($_REQUEST['saveSettings']))
	{
		// If new options were submitted, compare to old ones and set differences
		if(isset($_REQUEST["options"]) && is_array($_REQUEST["options"])) {
			$newOptions = array();
			$options = $_SESSION['interface']->getOptions(TRUE);
			// If we ever start caring about the output from the set commands,
			// this function will have to bear some rewrites.
			foreach($_REQUEST["options"] as $key => $value) {
				if(trim($value) != trim($options[$key])) {
					$newOptions[$key] = $value;
					$options[$key] = $value; //update Options
					$_SESSION['message'] .= _("Option changed") . ": $key: $options[$key] => $value<br />";
				}
			}
			$_SESSION['interface']->setOptions($newOptions);
		}
	
		if($_SESSION['interface']->saveOptions()) {
			$_SESSION['message'] .= _("Configuration files saved.").BN;
		} else {
			$_SESSION['message'] .= _("Could NOT save configuration files!").BN;
		}
	}
	return opt();
}
?>
