<?php
/**
* Shows file download details
*
* @author   Don Seiler <don@NOSPAM.seiler.us>
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function vd_details()
{
	$content = NULL;
	$file = NULL;
	
	if(!isset($_REQUEST["nr"]) OR is_array($_REQUEST["nr"])) {
		$_SESSION['message'] .= '<div class="error">'._("No items were selected.")."</div>";
		return vd();
	}
	
	if(!$_SESSION['user']->allow_show_Download($_REQUEST["nr"])) { 
		$_SESSION['message'] .= '<div class="error">'._("Access denied!")."</div>".BN;
		return vd();
	}

	$file = $_SESSION['interface']->getDownloadDetails($_REQUEST["nr"]);
	
	if(!$file->isvalid){ 
		$_SESSION['message'] .= '<div class="error">'._("File does not exist!"). "</div>";
		return vd();
	}

	$_SESSION['tmp'][$file->nr] = $file->name; //need for a hack in download_action()

	$_SESSION['headline'] = "<nobr>"._("Details").": ".$file->name."</nobr>\n";

	//javascript for name select list
        if ($_SESSION["core"]->use_javascript) {
		$content .= "<script language=\"JavaScript\">\n";
		$content .= "//<!--\n";
		$content .= "function updateBox() {\n";
		$content .= "  document.forms.rename.newname.value = document.forms.rename.newnameselect.options[document.forms.rename.newnameselect.selectedIndex].text;\n";
		$content .= "}\n";
		$content .= "//-->\n";
		$content .= "</script>\n";
        }

	$content .= '<form name="rename" action="index.php" method="POST">'.NL;
	$content .= '<input type="hidden" name="nr[]" value="'.$file->nr.'" />'.NL;
	$content .= '<input type="hidden" name="CORE_OP" value="vd_action" />'.NL;
	
	$content .= '<table width="40%" frame="box">'.NL;

	//display  select list of other file names
	if (is_array($file->names) AND count($file->names) > 1) {
		$content .= "<tr>\n";
		$content .= '<td><select name="newnameselect" style="width: 100%;"';
		if ($_SESSION["core"]->use_javascript) {
			$content .= ' onChange="javascript:updateBox()"';
		}
		$content .= ">\n";
		
		//$c = 0;
		foreach($file->names as $name) {
			//$c++; if($c > 150) {$content .= "<option>"._("Breaking off list!")."</option>\n"; break; } //hard coded limit , 150 should be enough...
			$content .= "<option>" . trim($name) . "</option>\n";
		}
		$content .= "</select></td>\n";
		
		$content .= '<td>';
		if ($_SESSION["core"]->use_javascript) {
			$content .= "&nbsp;";
		} else {
			$content .= '<input type="submit" name="renameselect" value="' . _("Rename") . "\" />";
		}
		$content .= "</td>\n";
		$content .= "</tr>\n";
	}
	
	$content .= "<tr>\n";
        $content .= '<td width="80%"><input name="newname" style="width: 100%" type="text" maxlength="200" value="'.$file->name."\" /></td>\n";
        $content .= '<td width="20%"><input type="submit" name="rename" value="' . _("Rename") . "\" /></td>\n";
	$content .= "</tr>\n";
	
	$content .= "</table>\n";
	
	$content .= "</form>\n";

	//display several file inforamtion
	$content .= "<table align=\"left\">\n";
	$content .= "<tr><td>"._("Owner").": </td><td>".$_SESSION['user']->getOwnerString($file->nr)."</td></tr>\n";
	$content .= "<tr><td>"._("Internal No.").": </td><td>".$file->nr ."</td></tr>\n";
	$content .= "<tr><td>"._("Network").": </td><td>".$file->network;
	if($file->network == "Donkey" AND strlen($file->hash) == 32) {
		$content .= ' (<a href="'.getED2KLink($file->name, $file->size, $file->hash).'">ED2K</a> ';
		//out of date
		//$content .= '/ <a href="http://stats.razorback2.com/ed2khistory?ed2k='.$file->hash.'" target="_blank">ed2khistory</a>';
		//$content .= '/ <a href="http://www.jugle.net/index.php?by=availibility&sort=DESC&availibility=1-2&type=HashSearch&searchstring='.$file->hash.'" target="_blank">jugle</a>)';
	}
	$content .= "</td></tr>\n";
	$content .= "<tr><td>"._("Hash").": </td><td>".$file->hash."</td></tr>\n";
	$content .= "<tr><td>"._("Size").": </td><td>".$file->size." Bytes (" .hrSize($file->size) .")</td></tr>\n";
	$content .= "<tr><td>"._("Downloaded").": </td><td>".$file->downloaded." Bytes (". hrSize($file->downloaded) . ")</td></tr>\n";
	$content .= "<tr><td>"._("Priority").": </td><td>".$file->priority."</td></tr>\n";
	$content .= "<tr><td>"._("Download Speed").": </td><td>".$file->speed."</td></tr>\n";
	$content .= "<tr><td>"._("Download Time Remaining at Current Speed").": </td><td>".hrTime($file->eta)."</td></tr>\n";
	$content .= "<tr><td>"._("Days in Download List").": </td><td>".$file->daysinlist."</td></tr>\n";
	$content .= "<tr><td>"._("Last Seen").": </td><td>".$file->lastseen."</td></tr>\n";
	$content .= "<tr><td>"._("Sources").": </td><td>".$file->numsources." ("._("Complete")."/"._("Parts").")</td></tr>\n";
	$content .= "<tr><td>"._("Availability").": </td><td>".round($file->availability, 1)."%</td></tr>\n";
	
	$content .= "</table>\n";
	$content .= "</div>\n";
	$content .= "<br clear=\"all\" /><br /><br />\n";
	
	// display chunks
	if (!empty($file->chunks)) {
	
		$content .= '<div align="center">'.NL;
		$content .= "<strong>" . _("Chunk Information") . "</strong><br />".BN;
		$content .= '<em><span class="chunk_missing">'._("Missing").'</span>|<span class="chunk_downloading">'._("Downloading").'</span>|<span class="chunk_finished">'._("Finished").'</span>|<span class="chunk_verified">'._("Verified").'</span></em>';
		$content .= "<br />".BN;
		$content .= drawChunkGraph($file->chunks, "75%", "20px");
		$content .= "</div>\n";
	}
	$content .= "<br /><br />\n";

	$content .= "<div align\"left\">\n";
	
	//display names
	if ($_SESSION['core']->max_displayed_names > 0) {
		$content .= "<br />\n<b>" . _("Other Names For This File") . "</b>: \n<ul>\n";
		if (!empty($file->names) AND count($file->names) > 1) {
			$c = 0;
			foreach($file->names as $name) {
				$c++; if($c > $_SESSION['core']->max_displayed_names) { $content .= "<li>"._("Breaking off list!")."</li>\n"; break; };
				$content .= "<li>$name</li>\n";
			}
		} else {
			$content .= "<li>" . _("None (empty)") . "</li>\n";
		}
		$content .= "</ul>\n";
	}
	
	//display sources
	if($_SESSION['core']->max_displayed_sources > 0) {
		$content .= "<br />\n<b>" . _("Sources For This File") . "</b>: \n";
		$content .= "<ul>\n";
		if(!empty($file->sources)) {
			$c = 0;
			foreach($file->sources as $source) {
				$c++; if($c > $_SESSION['core']->max_displayed_sources) { $content .= "<li>"._("Breaking off list!")."</li>\n"; break; };
				$content .= "<li>$source</li>\n";
			}
		} else {
			$content .= "<li>" . _("None (empty)") . "</li>\n";
		}
		$content .= "</ul>\n";
	}

	$content .= "</div>\n";
	return $content;
}

?>
