<?php
/**
* Lists files being downloaded
*
* @author  Don Seiler <don@NOSPAM.seiler.us>
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function vd() {
	$content = NULL;
	
	$_SESSION['headline'] =  _("Downloads");
	
	$headers = array();
        $headers["action"]	= "";
	$headers["owner"]	= _("Owner");
        $headers["name"]	= _("Name");
        $headers["percent"]	= _("%");
        $headers["downloaded"]	= _("Downloaded");
	$headers["size"]	= _("Size");
        $headers["old"]		= _("Old");
        $headers["priority"]	= _("Priority");
        $headers["speed"]	= _("Speed");
        $headers["eta"]		= _("ETA");
	$headers["numsources"]	= _("Sources");
        $headers["network"]	= _("Network");
	$columns = count($headers);
	
	$global_downrate = 0;
	$total_downloaded = 0;
        $total_size = 0;
	$total_downrate = 0;
	$finished_files_exist = FALSE;
	$all_files = $_SESSION['interface']->getAllDownloads();

	//filter downloads and get some info
	foreach($all_files as $file) {
		
		$global_downrate += $file->speed;
		
		if($_SESSION['user']->allow_show_Download($file->nr))
		{
			if($file->finished) {
				$finished_files_exist = TRUE;
			}
			//set some missing file variables
			$file->owner = $_SESSION['user']->getOwnerString($file->nr);
			
			$total_downloaded += $file->downloaded;
			$total_size += $file->size;
			$total_downrate += $file->speed;
			
			$file_array[] = $file;
		}
	}
	unset($all_files);

	$files = sort_objects($file_array, "speed",  "DESC", "vd");

	$content .= checkboxJavascript("nr[]");
        $content .= '<form name="vd" action="index.php" method="post">'.NL;
	$content .= '<table cellspacing="0" cellpadding="2" border="0" width="100%">'.NL;
	
	//print  All | None | Invert | Range
        $content .= '<tr><td colspan="'.$columns.'">'.NL;
        $content .= checkboxLinks("vd");
        $content .= "</td></tr>\n";
	
	//print header
	$content .= getTableHeader($headers, "vd");
	
	//show  files
	$c = 0;
	$theme_dir = $_SESSION['core']->subDirs['theme_dir'].$_SESSION['user']->theme;
	foreach($files as $equals) {	//$equals contains an array of File Objekts with equal sortvalue
		foreach($equals as $file)
		{
			if($c%2 == 0) { $content .= '<tr class="list">'.NL; }
			else { $content .= '<tr class="alt_list">'.NL; }
			
			//checkbox
			$content .= '<td rowspan="2"><input type="checkbox" name="nr[]" value="'.$file->nr.'" />'."</td>\n";
			
			//Owner,  Name,  Percent,  Downloaded,  Size,  Old
			$content .= '<td rowspan="2" align="center">'.$file->owner."</td>\n";
			$content .= '<td width="100%" align="left"><a href="index.php?CORE_OP=vd_details&nr='.$file->nr.'">'.hrName($file->name)."</a></td>\n";
			$content .= '<td rowspan="2" align="right">'. sprintf("%01.1f", $file->percent)."%</td>\n";
			$content .= '<td rowspan="2" align="right" nowrap="nowrap">'.hrSize($file->downloaded)."&nbsp;</td>\n";
			$content .= '<td rowspan="2" align="right" nowrap="nowrap">'.hrSize($file->size). "</td>\n";
			$content .= '<td rowspan="2" align="center">'.$file->old."</td>\n";
			
			// priority
			$content .= getPriorityTableCell($file->priority, 'rowspan="2" align="center"');

			// speed
			$content .= getSpeedTableCell($file->speed, 'rowspan="2" align="center"');
			
			//ETA, Sources
			$content .= '<td rowspan="2" align="center" nowrap="nowrap" width="70">'.hrTime($file->eta)."</td>\n";
			$content .= '<td rowspan="2" align="center">'.$file->numsources."</td>\n";
			$content .= '<td rowspan="2" align="center">'.formatNetwork($file->network, "image")."</td>\n";
	
			$content .= "</tr>\n";
			
			if($c%2 == 0) { $content .= '<tr class="list">'.NL; }
			else { $content .= '<tr class="alt_list">'.NL; }
			
			//print progressbar
			$content .= '<td><img src="'.$theme_dir.'/images/progressbar.png" width="'.$file->percent.'%" height="4"></td>'.NL;
			$content .= "</tr>\n";
			$c++;
		}
	}
	
	//if no files where  displayed
	if (count($files) == 0) {
		$content .= '<tr class="alt_list"><td align="center" colspan="'.$columns.'"><b>'._("No Files").'</b></td></tr>'.NL;
	}

	//print  All | None | Invert | Range
        $content .= '<tr><td colspan="'.$columns.'">'.NL;
        $content .= checkboxLinks("vd");
        $content .= "</td></tr>\n";
	
	//global speed display
        $content .= '<tr><td colspan="'.$columns.'" align="right" valign="top">'.NL;
        $content .= "<strong>".sprintf(_("%s of %s downloaded"), hrSize($total_downloaded), hrSize($total_size));
	//$content .= " @ &darr;".sprintf("%01.1f", $total_downrate)."&darr; (&darr;".sprintf("%01.1f", $global_downrate)." KB/s"."&darr;&uarr;".$_SESSION['interface']->getUploadRate()."&uarr;)";
	$content .= " @ ".sprintf("%01.1f", $total_downrate)." / ".sprintf("%01.1f", $_SESSION['interface']->upload_rate)." KB/s";
	$content .= "</strong>\n";
        $content .= "</td></tr>\n";

        $content .= '<tr><td colspan="'.$columns.'">'.NL;

	//Add/Cancel Button , select target  option
	$content .= getUserSelection();
	$content .= '<input type="submit" name="add_owner" value="' . _("Add") . '" />'.NL;
        $content .= '<input type="submit" name="cancel" value="' . _("Cancel") . '" />'.NL;
	$content .= "&nbsp;&nbsp;&nbsp;&nbsp;";
	
	//Buttons:  Pause, Resume, Commit (optional)
	$content .= '<input type="submit" name="pause" value="' . _("Pause") . '" />'.NL;
	$content .= '<input type="submit" name="resume" value="' . _("Resume") . '" />'.NL;
	if($finished_files_exist) {
		$content .= '<input type="submit" name="commit" value="' . _("Commit") . '" />'.NL;
	}
	$content .= "&nbsp;&nbsp;&nbsp;&nbsp;";

	//priority option / Set priority button
	$content .= getPrioritySelection();
	$content .= '<input type="submit" name="setpriority" value="' . _("Set Priority") . '" />'.NL;

        $content .= "</td></tr>\n";
	$content .= "</table>\n";
        $content .= '<input type="hidden" name="CORE_OP" value="vd_action" />'.NL;
        $content .= "</form>\n";

	return $content;
}

/**
* Handles bulk file operations
*
* @author   Don Seiler <don@NOSPAM.seiler.us>
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function vd_action()
{
	if(isset($_REQUEST["commit"])) {
		$_SESSION['interface']->commitDownloads();
		$_SESSION['message'] .= _("Files commited.").BN;
		return vd();
	}
	
	$toUser = $_REQUEST["toUser"];
	$nrs = $_REQUEST["nr"];
	
	if(empty($nrs) OR !is_array($nrs)) {
		$_SESSION['message'] .= '<div class="error">'._("No items were selected.")."</div>";
		return vd();
	}

        if(isset($_REQUEST["pause"])) {
		// Pause the array members
		$pause_nrs = array();
		foreach($nrs as $nr) {
			$name = hrName($_SESSION['interface']->get_name($nr));
			
			if($_SESSION['user']->allow_pause_Download($nr))
			{
				$pause_nrs[] = $nr;
			} else {
				$_SESSION['message'] .= sprintf(_("No permission to pause Download \"%s\"!"), $name).BN;
			}
		}
		if(!empty($pause_nrs))
		{
			$_SESSION['interface']->pauseDownloads($pause_nrs); 
			$_SESSION['message'] .= "<p>" . _("Download paused.") . "</p>\n";
		}
		
        } elseif(isset($_REQUEST["resume"])) {
		// Resume the array members
		$resume_nrs = array();
		foreach($nrs as $nr) {
			$name = hrName($_SESSION['interface']->get_name($nr));
			
			if($_SESSION['user']->allow_resume_Download($nr))
			{
				$resume_nrs[] = $nr;
			} else {
				$_SESSION['message'] .= sprintf(_("No permission to resume Download \"%s\"!"), $name).BN;
			}
		}
		if(!empty($resume_nrs)) {
			$_SESSION['interface']->resumeDownloads($resume_nrs);
			$_SESSION['message'] .= _("Downloads resumed.").BN;
		}
		
	} elseif(isset($_REQUEST["setpriority"])) {

		$priority_nrs = array();
		foreach($nrs as $nr) {
			$name = hrName($_SESSION['interface']->get_name($nr));
			
			if($_SESSION['user']->allow_prio_Download($nr)) {
				$priority_nrs[] = $nr;
			} else {
				$_SESSION['message'] .= sprintf(_("No permission to change %s of Download \"%s\"!"),_("Priority"), $name).BN;
			}
		}
		if(!empty($priority_nrs)) {
			$_SESSION['interface']->priorDownloads($priority_nrs, $_REQUEST["priority"]);
			$_SESSION['message'] .= _("Priorities updated.").BN;
		}
		
        } elseif(isset($_REQUEST["rename"])) {
		
		$nr = $nrs[0];
		$name = hrName($_SESSION['interface']->get_name($nr));

		if(!$_SESSION['user']->allow_rename_Download($nr)) {
			$_SESSION['message'] .= sprintf(_("No permission to change %s of download \"%s\"!"), _("Name"), $name).BN;
		} else {
			if (isset($_REQUEST["renameselect"])) {	$newname = $_REQUEST["newnameselect"]; }
			else {					$newname = $_REQUEST["newname"]; }
			if (get_magic_quotes_gpc()) {		$newname = stripslashes($newname); }
		
			$_SESSION['interface']->renameDownload($nr, $newname);
			$_SESSION['message'] .= _("Name changed.").BN;
		}
		
        } elseif(isset($_REQUEST["add_owner"])) {
	
		$size = array_sum(array_values($_SESSION['interface']->get_size($nrs)));
		$count = count($nrs);

		if($_SESSION['user']->allow_add_Downloads($count, $size, $toUser)) {
	
			$_SESSION['user']->add_Owner($nrs, $toUser);
		}

        } elseif(isset($_REQUEST["cancel"])) {
		if(isset($_REQUEST["YESCANCEL"])) {
			// Cancel the array members
			if(!$_SESSION['user']->allow_cancel_Downloads($toUser)) {
				$_SESSION['message'] .= sprintf(_("No permission to remove downloads of User/Group \"%s\"!"), $toUser).BN;
			} else {
				$del_nrs = array();
				$rem_nrs = array();
				
				foreach($_REQUEST['nr'] as $nr) {
					if($_SESSION['user']->downloaded_by_user($nr,$toUser)) {
						$rem_nrs[] = $nr;
						
						if($_SESSION['user']->username != "admin" AND !$_SESSION['user']->downloaded_by_others($nr,$toUser)) {
							$del_nrs[] = $nr;
						}
					} elseif($_SESSION['user']->username == "admin" AND $_SESSION['user']->num_of_downloads($nr) == 0) {
						$del_nrs[] = $nr;
					} else {
						$name = hrName($_SESSION['interface']->get_name($nr));
						$_SESSION['message'] .= sprintf(_("User/Group \"%s\" is no owner of download \"%s\"!"), $toUser, hrName($name)).BN;
					}
				}
				
				if(!empty($rem_nrs) OR !empty($del_nrs)) {
					$_SESSION['message'] .= sprintf(_("Downloads of User/Group \"%s\" cancelled."),$toUser).BN;
				}
				
				if(!empty($rem_nrs)) {
					$_SESSION['user']->removeDownloads($rem_nrs, $toUser);
				}
				if(!empty($del_nrs)) {
					$_SESSION['interface']->cancelDownloads($del_nrs);
				}
			}
			
		} elseif (isset($_REQUEST["NOCANCEL"])) {
			$_SESSION['message'] .= "<p>" . _("Downloads were NOT cancelled!") . "</p>\n"; 
		} else { // Print confirmation page
		
			$_SESSION['headline'] =  _("Cancel Downloads");
			$content = NULL;
			$content .= '<form name="cancelform" action="index.php" method="post">'.NL;
			$content .= '<input type="hidden" name="CORE_OP" value="vd_action" />'.NL;
			$content .= '<input type="hidden" name="cancel" value="1" />'.NL;
			$filenames = array();
			foreach($nrs as $nr) {
				$content .= '<input type="hidden" name="nr[]" value="'.$nr.'" />'.NL;
			}
			$content .= '<input type="hidden" name="toUser" value="'.$toUser.'" />'.NL;
			$content .= "<table>\n";
			$content .= "<tr><td>".sprintf(_("Are you sure you want to remove these downloads from User/Group \"%s\"?"), $toUser)."</b></td></tr>\n";
		     
			//print list of download names
			$content .= '<tr><td align="left">'.NL;
			$content .= getNameList($nrs);
			$content .= "</td></tr>\n";
			
			//Yes/No - Buttons
			$content .= "<tr><td>&nbsp;</td></tr>\n";
			$content .= "<tr><td align=\"center\">\n";
			$content .= '<input type="submit" name="YESCANCEL" value="'._("Yes").'" />'.NL;
			$content .= "&nbsp;&nbsp;&nbsp;\n";
			$content .= '<input type="submit" name="NOCANCEL" value="'._("No").'" />'.NL;
			$content .= "</td></tr>\n";
			$content .= "</table>\n";
			$content .= "</form>\n";
			return $content;
		}
        }
	return vd();
}
?>
