<?php

/*
* user_management() is an interface for the admin to alter all user settings
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function umanage() {

	$_SESSION['headline'] = _("User Management");
	
	//print user selection
	$usernames = array_keys($_SESSION['user']->userSettings);
	$temp = count($usernames);
	natcasesort($usernames);
	$i = 0;
	foreach($usernames as $username) {
		$i++;
		$content .= '<a href="index.php?CORE_OP=umanage&showUserDetails=1&username='.$username.'">'.$username."</a>";
		if($i < $temp){ $content .= ' |  '; }
	}
	$content .= "<br \>".BN;
	
	//add user
	$content .= '<form action="index.php" method="POST">'.NL;
	$content .= '<input type="text" name="newuser"  size="14" maxlength="14" />'.NL;
	$content .= '<input type="hidden" name="CORE_OP" value="umanage_action" />'.NL;
	$content .= '<input type="submit" name="addUser" value="'._("Add User")."\" />\n";
	$content .= "</form>\n";
	
	//show user details
	if($_GET['showUserDetails'] == '1' AND isset($_GET['username'])) // use of $_REQUEST because of the <a href... some lines above
	{
		$username = $_GET['username'];
		$content .= "<br \><br \><hr>\n";
		$content .= '<h3>'._("User").': "'.$username.'"</h3>';
		$content .= '<form action="index.php" method="post">'.NL;
		
		//get available titlebar settings
		$optItems = array_merge($_SESSION['core']->clientUpPanels, $_SESSION['core']->clientDownPanels); // all available panels
		if($username != "admin") { //group-/user management  doesn't work for normal users
			unset($optItems['umanage']);
			unset($optItems['gmanage']);
		}
		
		//print current user titlebar
		$content .= '<h4>'._("Current Titlebar").":</h4>\n";
		$content .= getSortableUserPanel($username, 'CORE_OP=umanage_action&username='.$username, $_SESSION['user']->userSettings[$username]['titlebar']);
		$content .= "<br \><br \>\n";
		
		//print titlebar item select table
		$content .= getSelectablePanelItems($username, $optItems, $_SESSION['user']->userSettings[$username]['titlebar']);
		$content .= "<br \><br \>\n";
		
		//settings
		$content .= '<h4>'._("Settings").":</h4>\n";
		$content .= '<table  border="0" cellpadding="5" cellspacing="0">'.NL;
		
		//password setting
		$content .= '<tr><td>'._("Password")." :</td>";
		$content .= '<td><input type="text" size="12" name="password" value="" /></td>';
		$content .= '<td><input type="submit" name="setUserPassword" value="'._("Set Password")."\" /></td></tr>\n";

		//language settings
		$content .= '<tr><td>'._("Language")." :</td>\n";
		$content .= '<td>'.getSelectList($_SESSION['core']->getLanguages(), $_SESSION['user']->userSettings[$username]['lang'], "newSettings[lang]")."<td>\n";
		$content .= "<td></td></tr>\n";
	
		//theme settings
		$content .= '<tr><td>'._("Theme")." :</td>\n";
		$content .= '<td>'.getSelectList($_SESSION['core']->getThemes(), $_SESSION['user']->userSettings[$username]['theme'], "newSettings[theme]")."<td>\n";
		$content .= "<td></td></tr>\n";
		
		$content .= '<tr><td>'._("Incoming").' :</td>';
		$content .= '<td><input type="text" size="12" name="newSettings[incoming]" value="'.$_SESSION['user']->userSettings[$username]['incoming'].'" /></td>';
		$content .= '<td>'._("Directory").'</td></tr>'.NL;
		
		$content .= '<tr><td>'._("Page Refresh").' :</td>';
		$content .= '<td><input type="text" size="12" name="newSettings[page_refresh]" value="'.$_SESSION['user']->userSettings[$username]['page_refresh'].'" /></td>';
		$content .= "<td>-1 ("._("Off")."),0 ("._("Menu")."), 1..9999 "._("Seconds")."</td></tr>\n";
		
		$content .= '<tr><td>'._("Max. Download Count").' :</td>';
		$content .= '<td><input type="text" size="12" name="newSettings[max_download_nr]" value="'.$_SESSION['user']->userSettings[$username]['max_download_nr'].'" /></td>';
		$content .= '<td>0 - 9999 X</td></tr>'.NL;
		
		$content .= '<tr><td>'._("Max. Download Volume").' :</td>';
		$content .= '<td><input type="text" size="12" name="newSettings[max_download_vol]" value="'.$_SESSION['user']->userSettings[$username]['max_download_vol'].'" /></td>';
		$content .= '<td>0 - 99999999 MB</td></tr>'.NL;
		
		$content .= '<tr><td>'._("Max. Name Length").' :</td>';
		$content .= '<td><input type="text" size="12" name="newSettings[max_name_len]" value="'.$_SESSION['user']->userSettings[$username]['max_name_len'].'" /></td>';
		$content .= '<td>0 - 9999 '._("Chars").'</td></tr>'.NL;

		$content .= '</table>'.NL;
		$content .= "<br \>".BN;
		
		//group membership
		$content .= '<h4>'._("Groups").":</h4>\n";
		$content .= '<table  border="0" cellpadding="5" cellspacing="0">'.NL;
		
		if($_SESSION['user']->userSettings[$username]['groups'] != NULL)
		{
			$content .= '<tr><td>'._("Group").'</td><td>'._("Add");
			$content .= '</td><td>'._("Cancel").'</td><td>'._("Pause/Resume");
			$content .= '</td><td>'._("Priority").'</td><td>'._("Rename")."</td><td></td></tr>\n";
			
			foreach($_SESSION['user']->userSettings[$username]['groups'] as $group => $rights)
			{
				//groupname
				$content .= '<tr align="center">'.NL;
				if($group != $username) {
					$content .= '<td><a href="index.php?CORE_OP=gmanage&showGroupDetails=1&groupname='.$group.'">'.$group."</a></td>\n";
				} else {
					$content .= '<td>'.$group."</td>\n";
				}
				
				//show permissions

				//add permission
				$content .= '<td><input type="checkbox" name="newSettings[groups]['.$group.'][]" value="1" ' ;
				if($rights%2 >= 1){  $content .='checked="checked"'; }
				$content .= " /></td>\n";
				
				//cancel permission
				$content .= '<td><input type="checkbox" name="newSettings[groups]['.$group.'][]" value="2" ';
				if($rights%4 >= 2){  $content .='checked="checked"'; }
				$content .= " /></td>\n";
				
				//pause/resume permission
				$content .= '<td><input type="checkbox" name="newSettings[groups]['.$group.'][]" value="4" ';
				if($rights%8 >= 4){  $content .='checked="checked"'; }
				$content .= " /></td>\n";
				
				//priorisize permission
				$content .= '<td><input type="checkbox" name="newSettings[groups]['.$group.'][]" value="8" ' ;
				if($rights%16 >= 8){  $content .='checked="checked"'; }
				$content .= " /></td>\n";

				//rename permission
				$content .= '<td><input type="checkbox" name="newSettings[groups]['.$group.'][]" value="16" ' ;
				if($rights%32 >= 16){  $content .='checked="checked"'; }
				$content .= " /></td>\n";
				
			}
		} else { $content .= "<tr><td>"._("None (empty)")."</td></tr>\n"; }
		
		$content .= '</table>'.NL;
		$content .= "<br \><br \>\n";
		
		//normal buttons
		$content .= '<input type="hidden" name="CORE_OP" value="umanage_action" />'.NL;
		$content .= '<input type="hidden" name="username" value="'.$username.'" />'.NL;
		$content .= '<input type="submit" name="setUserSettings" value="'._("Save Settings")."\" />\n";
		$content .= '<input type="submit" name="delUser" value="'._("Remove Account")."\" />\n";

		$content .= "</form>\n";
	}
	
	return $content;
}

/*
* handle all action performed in user management
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function umanage_action() {

	if(isset($_REQUEST['setUserSettings']))
	{
		$newSettings = $_POST['newSettings'];
		$username = $_POST['username'];
		
		//change the form of the rights  to string
		foreach($newSettings['groups'] as $group => $rights)
		{
			$tmp.= $group.":".array_sum($rights).":";
		}
		$newSettings['groups'] = substr($tmp, 0, -1); //removes the last ":"

		//apply order of the current titlebar to the new one as far as possible
		$newSettings['titlebar'] = apply_order($_SESSION['user']->userSettings[$username]['titlebar'], $newSettings['titlebar']);
	
		//user admin cannot disable  user- and group  management
		if($username  == "admin") {
			$newSettings['titlebar'] = array_unique(array_merge($newSettings['titlebar'], array("umanage", "gmanage")));
		}
		$_SESSION['user']->setUserSettings($username, $newSettings);
		
		//showUserDetails of edited user
		$_GET['showUserDetails'] = '1';
		$_GET['username'] = $username;
			
	} elseif(isset($_REQUEST['delUser'])) {

		if(isset($_POST['YESDELUSER'])){
			$_SESSION['user']->delUser($_POST['username']);
		}
		elseif(isset($_POST['NODELUSER'])){
			$_SESSION['message'] .= sprintf(_("%s \"%s\" was NOT removed!"), _("User"), $_POST['username']);
			$_GET['showUserDetails'] = '1';
			$_GET['username'] = $_POST['username'];
		} else {
			// Print confirmation page
			$content .= '<div align="center">'.NL;
			$content .= sprintf(_("Are you sure you want to remove the account of user \"%s\"?"), $_POST['username']).NL;
			$content .= '<form action="index.php" method="POST">'.NL;
			$content .= '<input type="hidden" name="CORE_OP" value="umanage_action" />'.NL;
			$content .= '<input type="hidden" name="delUser" value="1" />'.NL;
			$content .= '<input type="hidden" name="username" value="'.$_POST['username'].'" />'.NL;
			$content .= '<input type="submit" name="YESDELUSER" value="'._("Yes").'" />'.NL;
			$content .= "&nbsp;&nbsp;&nbsp;\n";
			$content .= '<input type="submit" name="NODELUSER" value="'._("No").'" />'.NL;
			$content .= "</form>\n</div>\n";
			return $content;
		}
			
	} elseif(isset($_REQUEST['addUser'])) {
					
		//default settings also possible to set in mysql
		$newSettings['password'] = 'd41d8cd98f00b204e9800998ecf8427e';
		$newSettings['titlebar'] = 'vd:s:logout';
		$newSettings['theme'] = 'default';
		$newSettings['lang'] = 'en_US';
		$newSettings['incoming'] = './';
		$newSettings['max_download_nr'] = '9999';
		$newSettings['max_download_vol'] = '99999999';
		$newSettings['max_name_len'] = '80';
		$newSettings['groups'] = $_POST['newuser'].':31';
		$newSettings['page_refresh'] = '-1';
		$_SESSION['user']->addUser($_POST['newuser'],$newSettings);
		
		//when the user was successfully added change the dtailed view to the new user, or restore the old view
		$_GET['showUserDetails'] = '1';
		if(in_array($_POST['newuser'], array_keys($_SESSION['user']->userSettings)))
		{
			$_GET['username'] = $_POST['newuser'];
		} else {
			$_GET['username'] = $_POST['username'];
		}
			
	} elseif(isset($_REQUEST['setUserPassword'])) {
	
		if(isset($_POST['password'])) {
			$_SESSION['user']->setUserPassword($_POST['username'],$_POST['password']);
		}
		//showUserDetails of edited user
		$_GET['showUserDetails'] = '1';
		$_GET['username'] = $_POST['username'];
		
	} elseif(isset($_REQUEST['moveItem'])) {
	
		$username = $_REQUEST['username'];
		$item = $_REQUEST['moveItem'];
		$move = $_REQUEST['move'];
		
		$titlebar = $_SESSION['user']->userSettings[$username]['titlebar'];
		$pos = array_search($item, $titlebar);
		
		$newTitlebar = array_move_elem($titlebar, $pos, 1, $move);
		$_SESSION['user']->setUserSettings($username, array('titlebar' => $newTitlebar));
		
		//showUserDetails of edited user
		$_GET['showUserDetails'] = '1';
		$_GET['username'] = $_REQUEST['username'];
	}
	
	return umanage();
}

?>