<?php

/*
* user_options() displays all options the user can change himself
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function uopt()
{
	$_SESSION['headline'] = _("User Options").': "'.$_SESSION['user']->username.'"';

	//print current user titlebar
	$content .= '<h4>'._("Current Titlebar").":</h4>\n";
	$content .= getSortableUserPanel($username, 'CORE_OP=uopt_action', $_SESSION['user']->titlebar);
	$content .= BN;

	//settings
	$content .= '<form action="index.php" method="post">'.NL;
	$content .= '<h4>'._("Settings").":</h4>\n";
	$content .= '<table  border="0" cellpadding="5" cellspacing="0">'.NL;

	//password settings
	$content .= '<tr><td>'._("Password")." :</td>";
	$content .= '<td><input type="text" size="12" name="password" value="" /></td>';
	$content .= '<td><input type="submit" name="setOwnPassword" value="'._("Set Password")."\" /></td></tr>\n";

	//language settings
	$content .= '<tr><td>'._("Language").' :</td>';
	$content .= "<td>".getSelectList($_SESSION['core']->getLanguages(), $_SESSION['user']->lang, "newSettings[lang]")."</td>\n";
	$content .= "<td></td></tr>\n";
	
	//theme settings
	$content .= '<tr><td>'._("Theme").' :</td>';
	$content .= "<td>".getSelectList($_SESSION['core']->getThemes(), $_SESSION['user']->theme, "newSettings[theme]")."</td>\n";
	$content .= "<td></td></tr>\n";
	
	//page refresh settings
	$content .= '<tr><td>'._("Page Refresh").' :</td>';
	$content .= '<td><input type="text" size="12" name="newSettings[page_refresh]" value="'.$_SESSION['user']->page_refresh.'" /></td>';
	$content .= "<td>-1 ("._("Off")."),0 ("._("Menu")."), 1..9999 "._("Seconds")."</td></tr>\n";
	
	$content .= '<tr><td>'._("Max. Name Length").' :</td>';
	$content .= '<td><input type="text" size="12" name="newSettings[max_name_len]" value="'.$_SESSION['user']->max_name_len.'" /></td>';
	$content .= "<td>1-9999 "._("Chars")."</td></tr>\n";
	
	$content .= '</table>'."<br />\n";
	$content .= '<input type="hidden" name="CORE_OP" value="uopt_action" />'.NL;
	$content .= '<input type="submit" name="setOwnSettings" value="'._("Save Settings")."\" />\n";
	$content .= "</form><br>\n";

	//fixed options
	$content .= '<h4>'._("Limits").":</h4>\n";
	$content .= '<table  border="0" cellpadding="5" cellspacing="0">'.NL;
	$content .= '<tr><td>'._("Max. Download Count").' :</td>';
	$content .= '<td>'.$_SESSION['user']->max_download_nr.' X</td>'.NL;
	$content .= '<tr><td>'._("Max. Download Volume").' :</td>';
	$content .= '<td>'.$_SESSION['user']->max_download_vol.' MB</td>'.NL;
	$content .= "</table><br>\n";

	//group membership
	$content .= '<h4>'._("Groups").":</h4>\n";
	
	$content .= '<table border="0" cellpadding="10" cellspacing="0">'.NL;
	$member_right = $_SESSION['user']->getMembership();
	if($member_right != NULL)
	{
		$content .= '<tr><td>'._("Group").'</td><td>'._("Add");
		$content .= '</td><td>'._("Cancel").'</td><td>'._("Pause/Resume");
		$content .= '</td><td>'._("Priority").'</td><td>'._("Rename")."</td></tr>\n";
			
		foreach($member_right as $groupname => $rights)
		{
			$content .= '<tr align="center">';
			
			$content .= '<td>'.$groupname."</td>";
			
			$content .= '<td>';
			if($rights%2 >= 1) {  $content .='<b>+</b>'; } else {  $content .='<b>-</b>'; }
			$content .= "</td>";
			
			$content .= '<td>';
			if($rights%4 >= 2) {  $content .='<b>+</b>'; } else {  $content .='<b>-</b>'; }
			$content .= "</td>";
			
			$content .= '<td>';
			if($rights%8 >= 4) {  $content .='<b>+</b>'; } else {  $content .='<b>-</b>'; }
			$content .= "</td>";
			
			$content .= '<td>';
			if($rights%16 >= 8) {  $content .='<b>+</b>'; } else {  $content .='<b>-</b>'; }
			$content .= "</td>";
			
			$content .= '<td>';
			if($rights%32 >= 16) {  $content .='<b>+</b>'; } else {  $content .='<b>-</b>'; }
			$content .= "</td>";

			$content .= "</tr>\n";
		}
	} else {
		$content .= "<tr><td>"._("None (empty)")."</td></tr>\n";
	}
	$content .= "</table>\n";

	return $content;
	
}

/*
* hadle all actions performed in user options
*
* @author Moritz Warning <mwarning@users.sourceforge.net>
*/
function uopt_action() {

	if(isset($_POST['setOwnPassword'])) {
		if(isset($_POST['password']))
		{
			$_SESSION['user']->setUserPassword($_SESSION['user']->username,$_POST['password']);
		}
		
	} elseif(isset($_POST['setOwnSettings'])) {
		$_SESSION['user']->setOwnSettings($_POST['newSettings']);
		
	} elseif(isset($_REQUEST['moveItem'])) {
	
		$username = $_REQUEST['username'];
		$item = $_REQUEST['moveItem'];
		$move = $_REQUEST['move'];
		
		$titlebar = $_SESSION['user']->titlebar;
		$pos = array_search($item, $titlebar);
		
		$newTitlebar = array_move_elem($titlebar,  $pos, 1, $move);
		$_SESSION['user']->setOwnSettings(array('titlebar' => $newTitlebar));
	}
	
	return uopt();
}

?>