<?php
/*
* place for share functions for themes
* at time, it is included by the core class file (but will be included by the template.php's in future)
*/


/*
* smooth_partition calcutates a homogenus distribution
* by a given number of  elements  used for titlebar patition
* $elems  = 14   ->  array(4,4,3,3)
* $elems  = 7   ->  array(3,2,2)
*/
function smooth_partition($elems) {

	$groups = round(sqrt($elems));
	$partition = array_pad(array(), $groups, 0);
	for($i = 0; $i < $elems; $i++) {
		$partition[$i%$groups]++;
	}
	return $partition;
}

/**
* Generate version string to display in footnote
*
* @author  Moritz Warning
*/	
function getVersionString()
{
	$version = '<a href="http://web-gmui.sourceforge.net" target="_blank" >Web-GMUI</a> ';
	$version .= $_SESSION['core']->version;
	$version .= ' / <a href="http://www.nongnu.org/mldonkey/" target="_blank">MLDonkey</a> Core ';
	$version .= $_SESSION['interface']->getClientVersion();
	return $version;
}

/*
*  formatNetwork formats "Donkey", "BiTorrent" etc. to shortcuts ("D", "BT" etc.)
* or a html link to an image; format can be "long", "short" or "image"
*
* @author  Moritz Warning
*/
function formatNetwork($network, $format = "long") {

	if($format == "short") {
		//the list need to be more complete
		$shortcuts = array (
			"Donkey" => "D",
			"BitTorrent" => "BT",
			"FastTrack" => "FT",
			"DirectConnect" => "DC",
			"FileTP" => "HTTP",
			"Gnutella" => "G",
			"Gnutella2" => "G2"
		);
		return $shortcuts[$network];
		
	} elseif($format == "image") {
		return '<img src="'.$_SESSION['core']->subDirs["lib_dir"]."images/".strtolower($network).'_connected.gif" alt="'.$network.'">';
		
	} else { //long output
		return $network;
	}
}

/*
* drawChunkGraph generates a html table with a chunk graph
* the chunk information is given by $chunks as an array of 0,1,2 or 3
*
* @author  Moritz Warning
*/
function drawChunkGraph($chunks, $width, $height)
{
	$len = strlen($chunks);
	$cellwidth = 100/$len;
	$content .= '<table frame="box" cellspacing="0" width="'.$width.'" height="'.$height."\"><tr>\n";
	for ($i = 0; $i < $len; $i++) {
		$content .= '<td class="chunk_';
		switch($chunks[$i]) {
			case "0":
				$content .= "missing";
				break;
			case "1":
				$content .= "downloading";
				break;
			case "2":
				$content .= "finished";
				break;
			case "3":
				$content .= "verified";
				break;
			default:
				// Note: this doesn't mean that the chunk is invalid,
				// it means that we got a number which shouldn't exist.
				$content .= "invalid";
		}
		$content .= "\"></td>\n";
	}
	$content .= "</tr></table>\n";
	return $content;
}

function getED2KLink($name, $size, $hash)
{
	return "ed2k://|file|".trim($name)."|".$size."|".$hash."|/";
}

function getTableHeader($headers, $CORE_OP) {
	$content = '<tr class="bg_dark">'.NL;
        foreach($headers as $key => $value)
		if($key != 'action') {
			$content .= '<th align="center"><a class="header" href="index.php?CORE_OP='.$CORE_OP.'&SORTKEY='.$key.'&SORTORDER=ASC">&darr;</a>'.$value.'<a class="header" href="index.php?CORE_OP='.$CORE_OP.'&SORTKEY='.$key.'&SORTORDER=DESC">&uarr;</a></th>'.NL;
		} else {
			$content .= "<th>$value</th>\n";
		}
        $content .= "</tr>\n";
	return $content;
}

function getTableHeader2($headers, $CORE_OP) {
	$content = '<tr class="bg_dark">'.NL;
	//$_SESSION['id']++;
	//$id = $_SESSION['id'];
	$_SESSION['core']->setRefreshed();
        foreach($headers as $key => $value)
		if($key != 'action') {
			$content .= '<th align="center"><a class="header" href="index.php?id='.$_SESSION['id']++.'&CORE_OP='.$CORE_OP.'&SORTKEY='.$key.'">'.$value.'</a></th>'.NL;
		} else {
			$content .= "<th>$value</th>\n";
		}
        $content .= "</tr>\n";
	return $content;
}


function getPriorityTableCell($priority, $param)
{
	$content .= '<td '.$param.'>';
	if(array_key_exists($priority, $_SESSION['core']->priorities)) {
		$priority = $_SESSION['core']->priorities[$priority];
		$content .= _($priority); 
	} else { 
		$content .= $priority;
	}
	$content .= "</td>\n";
	return $content;
}

function getSpeedTableCell($speed, $param)
{
	//determine background color class
	if ($speed != '-') {
		if     ($speed == "finished") { $class = "speed_finished"; } //need to add stylesheet class speed_finished?
		elseif ($speed == "paused")   { $class = "speed_paused"; }
		elseif ($speed <= 1)  { $class = "speed_slowest"; }
		elseif ($speed <= 3)  { $class = "speed_slow"; }
		elseif ($speed <= 5)  { $class = "speed_medium"; }
		elseif ($speed <= 10) { $class = "speed_fast"; }
		elseif ($speed <= 20) { $class = "speed_faster"; }
		elseif ($speed > 20)  { $class = "speed_fastest"; }
		$content .= '<td '.$param.' class="'.$class.'">';
	} else {
		$content .= '<td '.$param.' class="speed_none">';
	}
	//determine label
	if($speed == "finished")    { $content .= _("Ready"); }
	elseif ($speed == "paused") { $content .= _("Paused"); }
	else                        { $content .= $speed; }
	$content .= "</td>\n";
	return $content;
}

/*
*  hrTime() resize $seconds to a day hour minutes seconds format
*/

function hrTime($seconds)
{
	if(!is_numeric($seconds)) { return $seconds; }
	
	$spf = array("%ds", "%2dm:%02ds", "%2dh:%02dm", "%dd %02dh");
	//$spf = array("%ds", "%2dm:%02ds", "%2dh:%02dm:%02ds", "%dd %2dh:%02dm");
	$stf = array(60, 60, 24, 365);
	$time = array();
	for ($i = 0; $seconds > 0; $i++) {
		$time[] = $seconds % $stf[$i];
		$seconds = floor($seconds / $stf[$i]);
	}
	$c = count($time);
	return sprintf($spf[$c-1] , $time[$c-1], $time[$c-2]);
	//return sprintf($spf[$c-1] , $time[$c-1], $time[$c-2], $time[$c-3]);
}

/*
* hrSize() format size values of bytes into KB, MB ...
*/
function hrSize($bytes)
{
	if(!is_numeric($bytes)) { return $bytes; }
	
	$stf = array("&nbsp;&nbsp;B&nbsp;", " KB", " MB", " GB", " TB");
	for ($i = 0; $bytes >= 1024; $i++) {
		$bytes = $bytes/1024;
	}
	
	return sprintf("%01.1f", $bytes).$stf[$i];
}

/*
* hrName() resize $string to a default (or second param) length
* by keeping last four chars
* result in curious behavior when $size <= 5
*/
function hrName($string)
{
	if(func_num_args() == 2) { 
		$size = func_get_arg(1);
	} else { //default value
		$size = $_SESSION['user']->max_name_len;
	}
	
	$strlen = strlen($string);
	if($strlen <= $size) {
		return htmlentities($string);
	}
	if($size <= 5) { $size = 6; }
	$first = substr($string, 0, $size - 4);
	$last = substr($string, -4);
	
	return  htmlentities($first."*".$last);
}
?>